var AMLex_Trans;
if(!AMLex_Trans){
	AMLex_Trans = {};
}
/**
  *
  *
  */
AMLex_Trans._parseUrl = function(str){

	var divId;
	var paramString;
	var wholeFlagment;

	var posSharp = str.indexOf('#');
	var posParamDelimiter = str.indexOf('!');

	if(posSharp < 0){
	// #無!無
		var divId = "";
		var paramString = "";
		var wholeFlagment = "";

	}else if(posSharp > 0 && posParamDelimiter < 0){
	// #有!無
		var divId = str.substring(posSharp + 1);
		var paramString = "";
		var wholeFlagment = str.substring(posSharp);

	}else if(posSharp > 0 && posParamDelimiter > 0){
	// #有!有
		var divId = str.substring(posSharp + 1, posParamDelimiter);
		var paramString = str.substring(posParamDelimiter + 1);
		var wholeFlagment = str.substring(posSharp);

	}
	return {divId:divId,paramString:paramString,wholeFlagment:wholeFlagment};
}
/**
  * 
  * paramString: #より後が渡される前提
  */
AMLex_Trans._getParams = function(paramString){

	var rtn = {};

	var pairs = paramString.split('&');
	for(var i = 0; i < pairs.length; i++){
		var keyvalue = pairs[i].split('=');
		rtn[keyvalue[0]] = keyvalue[1];
		//alert('rtn[' + keyvalue[0] + ']:' + keyvalue[1]);
	}

	return rtn;

}
/**
  * 現在表示しているURLからパラメータをトークン化、配列にして
  * 渡すメソッド
  */
AMLex_Trans.getParams = function(){
	var curUrl = AMLex_Trans._parseUrl(window.location.href);
	return AMLex_Trans._getParams(curUrl.paramString);
}
AMLex_Trans._parseFlagment = function(flagment){

	if(flagment.charAt(0) == '#'){
		flagment = flagment.substring(1);
	}

	var rtn = flagment.split('!');
	if(rtn[1] == undefined){
		rtn[1] = '';
	}

	return {divId:rtn[0],paramString:rtn[1]};
}
/**
  * 把握している限りの現在表示中のページ(DIV)id
  * ""であればindexとして挙動(各メソッド内にて配慮)、
  * この値と差異があれば「戻る」ボタンによる遷移と判断し
  * toメソッドによるページ読込が開始される
  */

AMLex_Trans._currentDetectedWholeFlagment = AMLex_Trans._parseUrl(window.location.href).wholeFlagment;


/**
  * 戻るボタンを使ったURLの遷移を検知
  *
  */
AMLex_Trans._observeUrl = function(){
	setTimeout(
		function(){

			var curUrl = AMLex_Trans._parseUrl(window.location.href);

			if(curUrl.wholeFlagment != AMLex_Trans._currentDetectedWholeFlagment){
				AMLex_Trans.to(curUrl.wholeFlagment);
			}
			
			setTimeout(arguments.callee, 300);
		}
		, 300);
}
window.addEventListener('load', AMLex_Trans._observeUrl, false);

// TODO: anchorを動的に追加する時のイベントハンドリングを事前に行うラッパー
/**
  * ページ遷移時の挙動を定義
  * @params pageDst...format: #fragment(!params...)
  *
  * onLoadOnce, onLoadEach, onGivenNewParams, onUnload
  * 上記擬似イベントの発行
  *
  * AMLex_Trans.pages内部プロパティ一覧:
  * AMLex_Trans.pages.*._isLoadedOnce
  * AMLex_Trans.pages.*._previousParamString
  * AMLex_Trans.pages.*._psv (Page-Scope Variable)
  *
  * 実装予定:
  * AMLex_Trans.pages.*._pisv (Page-Instance-Scope Variable)
  *
  */

AMLex_Trans.to = function(pageDst){

	var pageElems = document.getElementById('pageset').childNodes;
	var dstPageElem;

	// 遷移前にonUnloadイベントを実行
	var previousId = AMLex_Trans._currentDetectedWholeFlagment;
	if(previousId == '' || previousId == '#'){
		previousId = '#page-menu';
	}
	// #を削除
	previousId = previousId.substring(1);

	var previousPageInfo = AMLex_Trans.pages[previousId];
	if(previousPageInfo != undefined){
			var func_unload = previousPageInfo['onUnload'];
			// 親HTML呼び出し時のObserverによる呼び出しの場合を判別
			var loadedCurrentPageBefore = previousPageInfo['_isLoadedOnce'];
			if(func_unload != undefined && loadedCurrentPageBefore != undefined){
					func_unload();
			}
	}

	var flagment;
	if(pageDst == '' || pageDst == '#'){
		flagment = '#page-menu';
	}else{
		flagment = pageDst;
	}
	
	// 遷移先URLをページIDとパラメータに分離
	//alert("flagment(origin of dstUrl):" + flagment);
	var dstUrl = AMLex_Trans._parseFlagment(flagment);
	//alert("dstUrl.divId:" + dstUrl.divId + "/dstUrl.paramString:" + dstUrl.paramString);

	// ページの非表示 or 表示の切替
	for(var i = 0; i < pageElems.length; i++){
		if(pageElems[i].nodeType == '1' && pageElems[i].tagName.toUpperCase() == 'DIV'){
			if(pageElems[i].style.display == 'block'){
				pageElems[i].style.display = 'none';
			}
			if(pageElems[i].id == dstUrl.divId){
				dstPageElem = pageElems[i];
				dstPageElem.style.display = 'block';

			}
		}
	}

	// 初回表示時の処理
	var dstPageInfo = AMLex_Trans.pages[dstUrl.divId];

	if(dstPageInfo != undefined){
		if(AMLex_Trans.pages[dstUrl.divId]._psv == undefined){
			AMLex_Trans.pages[dstUrl.divId]._psv = {};
		}
	}
	
	if(dstPageInfo != undefined && !dstPageInfo._isLoadedOnce){

			// 未ロードのページの場合、アンカーに対してイベントハンドリングを行う
			var anchors = dstPageElem.getElementsByTagName('a');
			for(var i = 0; i < anchors.length; i++){
				var href = anchors[i].href;
				if(href.substring(0,1) == '#'){
					anchors[i].addEventListener('click', (function(href){return function(){
						AMLex_Trans.to(href);
					}})(href), false);
				}
			}

			// JavaScriptの制御(一回限り呼ばれるonLoadOnceが定義されている場合、
			// _isLoadedOnceフラグが立っていなければ実行する)

			var func_loadOnce = dstPageInfo['onLoadOnce'];
			if(func_loadOnce != undefined){
				//alert("onLoadOnce is to be executed in behave of " + window.location.href);
				func_loadOnce();
			}
	}


	if(dstPageInfo != undefined){
			// JavaScriptの制御(毎回呼ばれるonLoadEachを実行)
			var func_loadEach = dstPageInfo['onLoadEach'];
			if(func_loadEach != undefined){
				//alert("onLoadEach is to be executed in behave of " + window.location.href);
				func_loadEach();
			}

			// JavaScriptの制御(パラメータが代わる度に呼ばれるonGivenNewParamsを実行)
			var func_givenNewParams = dstPageInfo['onGivenNewParams'];
			if(func_givenNewParams != undefined){
				if(dstPageInfo._previousParamString == undefined){
					//alert("_previousParamString undefined");
					// ページ初回表示時の場合
					func_givenNewParams(AMLex_Trans._getParams(dstUrl.paramString));

				}else if(dstPageInfo._previousParamString != dstUrl.paramString){
					//alert("_previousParamString is differ from the stored");
					// private変数が定義済みでかつ前回と異なる場合
					func_givenNewParams(AMLex_Trans._getParams(dstUrl.paramString));
				}
			}
	}


	// _isLoadedOnceフラグを立てる
	if(dstPageInfo == undefined){
		AMLex_Trans.pages[dstUrl.divId] = {};
		AMLex_Trans.pages[dstUrl.divId]._psv = {};
	}
	AMLex_Trans.pages[dstUrl.divId]._isLoadedOnce = true;
	AMLex_Trans.pages[dstUrl.divId]._previousParamString = dstUrl.paramString;

	// 現在表示しているページ(div)情報を更新
	AMLex_Trans._currentDetectedWholeFlagment = pageDst;

};
AMLex_Trans.getPSV = function(variableName){

	var URLTokens = AMLex_Trans._parseUrl(window.location.href);	
	
	// _psvはページ初回ロード時に確保される仕様であるため、
	// _psvはオブジェクトとして初期化されている前提。
	// 仮に_psvが初期化されていない場合、下記でnull参照が
	// 発生しうる

	return 	AMLex_Trans.pages[URLTokens.divId]._psv[variableName];
}
AMLex_Trans.setPSV = function(divId, variableName, value){

	if(variableName in AMLex_Trans.pages[divId]._psv){
		AMLex_Trans.pages[divId]._psv[variableName] = value;
	}else{
		AMLex_Trans.pages[divId]._psv[variableName] = {};
		AMLex_Trans.pages[divId]._psv[variableName] = value;
	}
}
AMLex_Trans.lookupPSV = function(divId, variableName){

	if(divId == ''){
		divId = AMLex_Trans._parseUrl(window.location.href);	
	}

	return 	AMLex_Trans.pages[divId]._psv[variableName];
}

AMLex_Trans.onCompleteDetector = function(){
		var pages = document.getElementById('pageset');
		if(pages == undefined){
			setTimeout(AMLex_Trans.onCompleteDetector , 100);
		}
		AMLex_Trans.to(AMLex_Trans._currentDetectedWholeFlagment);
}
//DOMContentLoadedはiPhone3Gで反応せず
window.addEventListener('load', AMLex_Trans.onCompleteDetector, false);  

AMLex_Trans.pages = {};
